<?php

/* **************************************************************************
MisterEstate - a Joomla Component

File:			class.estateagent.php
Copyright: 		2004 - 2007 by Darko Selesi
Homepage: 		http://www.misterestate.com
Created with: 	Eclipse 3.2.0 (http://www.eclipse.org)
			  	on RedHat/Fedora Linux (http://fedora.redhat.com)
License: 		GNU/GPL http://www.gnu.org/copyleft/gpl.html
*************************************************************************** */


defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class EAObject extends mosDBTable {
    
	var $id = 0;
  	var $obj_id = "";
  	var $cat = 0;
  	var $type = "";
  	var $title = "";
  	var $description ="";
  	var $location = "";
  	var $condition = "";
  	var $other = "";
  	var $rooms = 0;
	var $bedrooms = 0;
	var $wc = 0;
  	var $space = 0;
  	var $homes = 0;
  	var $homes_size = 0;
  	var $pp_size = 0;
  	var $trade_units = 0;
  	var $trade_size = 0;
  	var $position = "";
  	var $lift = 0;
	var $handicap = 0;
  	var $yobuilt = 0;
  	var $toheat = 0;
  	var $toheat_ufloor = 0;
  	var $fireside = 0;
	var $aircondition = 0;
	var $tv = 0;
	var $dsl = 0;	
	var $balcony = 0;
  	var $terrace = 0;
	var $swpool = 0;
  	var $garden = 0;
  	var $parkarea = 0;
  	var $garage = 0;
  	var $rent = 0;
  	var $rent_extra = 0;
  	var $price = "0.00";
  	var $commis = 0;
  	var $secure = 0;
  	var $receipts = 0;
  	var $street = "";
  	var $streetnr = "";
  	var $pcode = "";
  	var $town = "";
  	var $district = "";
  	var $state = "";
  	var $country = "";
  	var $hits = 0;
  	var $hot = 0;
  	var $metadesc = "";
  	var $metakey = "";
  	var $created = "0000-00-00";
  	var $created_by = 0;
  	var $access = 0;
  	var $verified = -1;
  	var $publish_up = "0000-00-00";
  	var $publish_down = "0000-00-00";  	
  	var $publish = 0;

  	function EAObject( &$db ) {
    	$this->mosDBTable( '#__estateagent', 'id', $db );
  	}
		
	function countHits() {
		 
		 $query = "UPDATE #__estateagent SET hits=(hits+1) WHERE id=$this->id";
 	     $this->_db->setQuery($query);
 	     $this->_db->query();
	}
		
	function filterAttributes() {
				
		$this->prepareAttributes();
		
		$attb = null;
				
		$singletype = array
		(
				_EA_OBJ_ROOMNR => $this->rooms,
				_EA_OBJ_BEDROOMS => $this->bedrooms,
				_EA_OBJ_WC => $this->wc,
				_EA_OBJ_DWSPACE => $this->space		
		);
		
		$multitype = array
		(
				_EA_OBJ_HOMES => $this->homes,
  				_EA_OBJ_HOMES_SIZE => $this->homes_size,
  				_EA_OBJ_PP_SIZE => $this->pp_size,
  				_EA_OBJ_TRADE_UNITS => $this->trade_units,
  				_EA_OBJ_TRADE_SIZE => $this->trade_size		
		);
		
		$standard = array
		(  				
  				_EA_OBJ_POSITION => $this->position,
  				_EA_OBJ_LIFT => $this->lift,
				_EA_OBJ_HANDICAP => $this->handicap,
  				_EA_OBJ_YOBUILT => $this->yobuilt,
  				_EA_OBJ_TOHEAT => $this->toheat,
  				_EA_OBJ_TOHEAT_UFLOOR => $this->toheat_ufloor,
  				_EA_OBJ_FIRESIDE => $this->fireside,
				_EA_OBJ_AIRCONDITION => $this->aircondition,
				_EA_OBJ_TV => $this->tv,
				_EA_OBJ_DSL => $this->dsl,	
				_EA_OBJ_BALCONY => $this->balcony,
  				_EA_OBJ_TERRACE => $this->terrace,
				_EA_OBJ_POOL => $this->swpool,
  				_EA_OBJ_GARDEN => $this->garden,
  				_EA_OBJ_PAREA => $this->parkarea,
  				_EA_OBJ_GARAGE => $this->garage				
		);
		
		if($this->type==1 || $this->type==2)
			$attb = array_merge($singletype,$standard);
		else $attb = array_merge($multitype,$standard);
				
		return $attb;
				
	}
		
	function prepareAttributes() {
		global $ea_measure;
				
		if($this->space!=0.00) $this->space .= " ".$ea_measure;
		if($this->homes_size!=0.00) $this->homes_size .= " ".$ea_measure;
		if($this->pp_size!=0.00) $this->pp_size .= " ".$ea_measure; 
		if($this->trade_size!=0.00) $this->trade_size .= " ".$ea_measure; 
		
		if($this->lift) $this->lift = _EA_STMT_YES;
		if($this->handicap) $this->handicap = _EA_STMT_YES;
  		if($this->toheat_ufloor) $this->toheat_ufloor = _EA_STMT_YES;
  		if($this->fireside) $this->fireside = _EA_STMT_YES;
  		if($this->aircondition) $this->aircondition = _EA_STMT_YES;		
  		if($this->tv) $this->tv = _EA_STMT_YES;
  		if($this->dsl) $this->dsl = _EA_STMT_YES;			
		if($this->balcony) $this->balcony = _EA_STMT_YES;	
		if($this->terrace) $this->terrace = _EA_STMT_YES;	
		if($this->swpool) $this->swpool = _EA_STMT_YES;				
  		if($this->garden) $this->garden = _EA_STMT_YES;
  		if($this->parkarea) $this->parkarea = _EA_STMT_YES;		
		if($this->garage) $this->garage = _EA_STMT_YES;	
  		  					
	}
	
	function filterFinancialData(){
				
		$rent = array(			
				_EA_OBJ_RENT => $this->rent,
  				_EA_OBJ_ECOSTS => $this->rent_extra,
  				_EA_OBJ_SECURE => $this->secure
  			);
  		$price = array(
  				_EA_OBJ_PRICE => $this->price,
  				_EA_OBJ_RENT_RCPTS => $this->receipts
  			);
  		$additional = array(
  				_EA_OBJ_COMMIS => $this->commis  				
  			); 		
  		
  		if($this->type==1 || $this->type==3)
  			$fncattb = array_merge($rent,$additional);
  		else
  			$fncattb = array_merge($price,$additional);
  				
		return $fncattb;
	}
		
	function filterLocationData(){
		
		$lc = new StdClass();
		$lc->street 	= $this->street;
		$lc->streetnr 	= $this->streetnr;
		$lc->pcode 		= $this->pcode;
		$lc->town	 	= $this->town;
		$lc->district 	= $this->district;
		$lc->state		= $this->state;
		$lc->country	= $this->country;
  				
		return $lc;
		
	}
	
	function parseCategoryShortInfo($ps,$value=0,$country,$state,$town,$district){

		$sh = array();		
		$si = array($value,$country,$state,$town,$district);

		for($x=0;$x<count($si);$x++){
			if($ps[$x] && ($si!=0 || $si[$x]!="")) $sh[] = $si[$x]; 
		}	

		$sh = implode(" / ",$sh);

		return $sh;
	}	

	function getObjectImages($oid=null){
		
		if($oid){
			$this->id = $oid;
		}		
		$query = "SELECT id FROM #__estateagent_images WHERE objid ='".$this->id."'";
		$this->_db->setQuery($query);
		$result = $this->_db->loadResultArray();
				
		return $result;
	}

	function loadPictures($oid=null,$own=null) {
  		global $my;

  		if($oid){
			$this->id = $oid;
		}
		
  		if($own == null) {
  			$this->_db->setQuery("SELECT id,objid,title,description,fname,type,path FROM #__estateagent_images WHERE owner = $my->id AND objid != $this->id AND (type = '.jpg' OR type = '.gif' OR type = '.png') ORDER BY ordering ASC");
  		}
  		else{
  			$this->_db->setQuery("SELECT * FROM #__estateagent_images WHERE objid = $this->id AND (type = '.jpg' OR type = '.gif' OR type = '.png') ORDER BY ordering ASC");
  		}
  		$result = $this->_db->loadObjectList();
  		  		 		
  		return $result;
  	}

	// for evaluation only ------------------------------------
	function loadFiles($oid=null,$t=null) {
  		global $database, $my;
  		
		if($oid){
			$this->id = $oid;
		}
		if($t == null) {
			$this->_db->setQuery("SELECT * FROM #__estateagent_images WHERE objid = $this->id AND type != '.jpg' AND type != '.gif' AND type != '.png' ORDER BY type,ordering ASC");
  			$result = $this->_db->loadObjectList();
		}
		else{
  			$this->_db->setQuery("SELECT * FROM #__estateagent_images WHERE objid = $this->id AND type = '.pdf' ORDER BY ordering ASC");
  			$result['pdf'] = $this->_db->loadObjectList();
  					
			$this->_db->setQuery("SELECT * FROM #__estateagent_images WHERE objid = $this->id AND (type = '.avi' OR type = '.mov' OR type = '.swf' OR type = '.mpg' OR type = '.mp4' OR type = '.mpeg') ORDER BY ordering ASC");
  			$result['mov'] = $this->_db->loadObjectList();
 			
			$this->_db->setQuery("SELECT * FROM #__estateagent_images WHERE objid = $this->id AND (type = '.doc' OR type = '.xls' OR type = '.ppt') ORDER BY ordering ASC");
  			$result['msdoc'] = $this->_db->loadObjectList();
			
			$this->_db->setQuery("SELECT * FROM #__estateagent_images WHERE objid = $this->id AND (type = '.odt' OR type = '.odp' OR type = '.ods') ORDER BY ordering ASC");
  			$result['ooffice'] = $this->_db->loadObjectList();
  		}
	
  		return $result;
  	}

	function countrySelectList(){
		global $mosConfig_absolute_path;
		
		// to change the entries of the countries selectlist, edit this file and your languagefile			
		require($mosConfig_absolute_path."/components/com_estateagent/includes/countries.inc.php");
			
		$c = array();
		while(list($key,$val) = each($countries)) { 
			$c[] = mosHTML::makeOption( $key, $val );	
		}
		return $c;		
	}

	function countryISOtoName($c_iso){
		global $mosConfig_absolute_path;

		require($mosConfig_absolute_path."/components/com_estateagent/includes/countries.inc.php");
		
		while(list($key,$val) = each($countries)) { 
			if($key == $c_iso){
				$cntry = $val;
				break;
			}
		}
		
		return $cntry;	
	}	

	function countryNameToISO($country){
		global $mosConfig_absolute_path;

		require($mosConfig_absolute_path."/components/com_estateagent/includes/countries.inc.php");
		
		$iso_code = "";
		while(list($key,$val) = each($countries)) { 
			if($val == $country){
				$iso_code = $key;
				break;
			}
		}
		
		return $iso_code;	
	}	

}
class EACategory extends mosDBTable {

  	var $id = 0;
  	var $name = "";
  	var $description = "";
  	var $parent = 0;
  	var $ordering = 0;
  	var $access = 0;
  	var $publish_up = "0000-00-00";
  	var $publish_down = "0000-00-00";
  	var $publish = 0;

	function EACategory( &$db ) {
    	$this->mosDBTable( '#__estateagent_categories', 'id', $db );
  	}
 	
	function getCatEntries($id=null){
				
		if ($id) {
			$this->id = intval( $id );
		}
		$query  = "SELECT id FROM #__estateagent WHERE cat = '".$this->id."'";
		$this->_db->setQuery($query);
        $result = $this->_db->loadResultArray();
				
		return $result;
	}
	
	function getSubcategories($id=null, $gid=1000){
		global $today;
		
		if ($id) {
			$this->id = intval( $id );
		}
		$query  = "SELECT * FROM #__estateagent_categories"
					. " WHERE"
					. " ("
					. "\n ((publish_up >= '0000-00-00' AND publish_up <= '$today') AND publish_down >= '$today')"
       				. "\n OR ((publish_up >= '0000-00-00' AND publish_up <= '$today' ) AND (publish_down = '0000-00-00' OR publish_down >= '$today'))"
       				. "\n OR (publish_up = '0000-00-00' AND publish_down = '0000-00-00')"
       				. "\n )"
					. " AND parent = $this->id AND access <= $gid AND publish='1' ORDER BY ordering";
		$this->_db->setQuery($query);
        $result = $this->_db->loadObjectList();
		
		return $result;				
	}
}

class EAImage extends mosDBTable {

	var $id = 0;
  	var $objid = 0;
  	var $title = "";
  	var $description = "";
  	var $fname = "";
  	var $type = "";
  	var $path = "";
  	var $owner = 0;
  	var $ordering = 1;
  	var $publish = 0;
  	  	
	function EAImage( $db ) {
    	$this->mosDBTable( '#__estateagent_images', 'id', $db );
  	}
  	
	function checkForPics($oid){
  		global $database, $mosConfig_live_site;
  				
  		$p = null;

		$query = "SELECT id FROM #__estateagent_images WHERE objid = $oid AND (type = '.jpg' OR type = '.gif' OR type = '.png') AND ordering = 1 AND publish = 1";
  		$database->setQuery($query);
  		$database->loadObject($p);
  		
		if($p != null) {
			return "<img src=\"$mosConfig_live_site/components/com_estateagent/gui/camera.png\"";
		}
		else{
			return "";
  		}
	}
  	  	
  	function loadFirstPic($oid, $path, $pwidth){
  		global $database, $mosConfig_absolute_path, $mosConfig_live_site;
  		
		$html = "";
		$file = "nopic.png";
		$picpath = $path; 		  		
  		$p = null;

		$query = "SELECT title,fname,type,path FROM #__estateagent_images WHERE objid = $oid AND (type = '.jpg' OR type = '.gif' OR type = '.png') AND ordering = 1 AND publish = 1";
  		$database->setQuery($query);
  		$database->loadObject($p);
  		
		if($p != null) {
				$picpath = ($p->path == "")? $picpath : $p->path;
				$p1 = "t" . $p->fname.$p->type;
				$p2 = $p->fname.$p->type;
				$file = (file_exists($mosConfig_absolute_path.$picpath.$p2))? $p2 : (file_exists($mosConfig_absolute_path.$picpath.$p1))? $p1 : $file;				
  		}
		
		$html =	"<img src=\"".$mosConfig_live_site.$picpath.$file."\" title=\"powered by MisterEstate\" border=\"0\" width=\"".$pwidth."\"/>";
		
		return $html;
  	} 
  	
	// overwritten standard delete method
	function delete($oid=null){
		global $mosConfig_absolute_path, $database;

		if($oid){
			$this->id = $oid;
		}
		// is the image file linked to another object?
		$query = "SELECT id FROM #__estateagent_images WHERE fname = '".$this->fname."' AND id != '".$this->id."'";
		$this->_db->setQuery($query);
  		if($this->_db->loadResult() == null) {	
  			if(chdir($mosConfig_absolute_path.$this->path)) {
	    		$img = $this->fname.$this->type;
    			$thumb = "t".$this->fname.$this->type;
	    		@chmod($img, 0777);
    			@chmod($thumb, 0777);
    			unlink($img);
				unlink($thumb);
    		}
		}
		 
        $query = "DELETE FROM #__estateagent_images"
        			. " WHERE id = '". $this->id ."'";
        $this->_db->setQuery( $query );
  
        if ($this->_db->query()) {
        	return true;
        } else {
        	$this->_error = $this->_db->getErrorMsg();
            return false;
        }	
	}
}

class mosEAUser extends mosUser {

	function getUserIDs(){
		global $database;
		
        $query = "SELECT DISTINCT created_by FROM #__estateagent";
		$database->setQuery($query);
		$result = $database->loadObjectList();
		#echo $database->getErrorMsg();      
        	
        return $result;
		
	}
	
	function getUsername($uid){
		global $database;
				
		$query  = "SELECT username FROM #__users WHERE id='".$uid."'";
		$database->setQuery($query);
        $result = $database->loadResult();
				
		return $result;		
		
	}

}

// ************* extended Mambo/Joomla! HTML classes, customized for EA 1.0 by Darko Selesi
// ************* original classes copyright (C) 2000 - 2005 Miro International Pty Ltd / OpenSourceMatters.org
class mosEAHTML extends mosHTML {

	// shows a coloured radiobutton-list ------------------------------	
	function radioList( &$arr, $tag_name, $tag_attribs, $selected=null, $key='value', $text='text' ) {
          reset( $arr );
          $html = "";
          for ($i=0, $n=count( $arr ); $i < $n; $i++ ) {
              $k = $arr[$i]->$key;
              $t = $arr[$i]->$text;
              $id = @$arr[$i]->id;
  
              $extra = "";
              $extra .= $id ? " id=\"" . $arr[$i]->id . "\"" : '';
              if (is_array( $selected )) {
                  foreach ($selected as $obj) {
                      $k2 = $obj->$key;
                      if ($k == $k2) {
                          $extra .= " selected=\"selected\"";
                          break;
                      }
                  }
              } else {
                  $extra .= ($k == $selected ? " checked=\"checked\"" : '');
              }
              $html .= "<input type=\"radio\" name=\"$tag_name\" value=\"".$k."\"".$tag_attribs." ".$extra." /><span style=\"width:35px; border-style:solid;border-color:#666666;border-width:1px;background-color:".$k."\">".$t."</span>";
          }
          $html .= "\n";
          return $html;
    }
	
	// shows a single checkbox ----------------------------------
    function checkbox( $name, $tag_attribs, $value, $text='', $showtext=0, $checked=null ) {
        $html = "";
				
        $t = ($showtext == '1')? "&nbsp".$text : '';
        $checked = ($checked == 1)? " checked=\"checked\"" : '';
        $html .= "<input type=\"checkbox\" name=\"".$name."\" ".$tag_attribs." value=\"".$value."\"".$checked." />".$t;
          
        return $html;
    }
	
	// shows a group of checkboxes ----------------------------------
    function checkboxList( &$arr, $tag_name, $tag_attribs, $key='value', $text='text', $checked=array(0,0,0,0,0) ) {
        reset( $arr );
        $html = "";
          
		for ($i=0, $n=count( $arr ); $i < $n; $i++ ) {
              $k = $arr[$i]['key'];
              $t = $arr[$i]['text'];
              
              $extra = ($checked[$i] == 1)? " checked=\"checked\" " : "";
              
              $html .= "<input type=\"checkbox\" name=\"".$tag_name."\" value=\"".$k."\"".$extra." ".$tag_attribs." />".$t."</input>&nbsp;";
        }
         
		return $html;
    }
}

// ************** more MisterEstate functions *****************
function createRSS($option,$act,$task,$today){
	global $mosConfig_absolute_path;
			
	include( $mosConfig_absolute_path .'/includes/feedcreator.class.php' );
	include( $mosConfig_absolute_path .'/components/com_estateagent/includes/rsscreator.php' );
   	exit();
    
}
	
function emailToFriendLink( $oid, $type ) {
	global $mosConfig_live_site;
          
	$html = ""; 
    $status = 'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=480,height=230,directories=no,location=no';
    $link = $mosConfig_live_site .'/index2.php?option=com_estateagent&amp;act=object&amp;task=mtfform&amp;Itemid=1&amp;id='. $oid;
    if ( $type==2 ) {
    	$image = mosAdminMenus::ImageCheck( 'emailButton.png', '/images/M_images/', NULL, NULL, _CMN_EMAIL, _CMN_EMAIL );
    } else {
       	$image = '&nbsp;'. _CMN_EMAIL;
    }         	
	
    $html .= "<a href=\"javascript:void(0)\" onclick=\"window.open('".$link."','MisterEstate','".$status."');\" title=\""._CMN_EMAIL."\">";
    $html .= $image;
    $html .= "</a>";
    	
	return $html;
}

function checkEmail($email){	
	$check = false;
    if (preg_match( "/[\w\.\-]+@\w+[\w\.\-]*?\.\w{1,4}/", $email )) {
       	$check = true;
    }
	return $check; 
}

function showPrintIcon() {  // not ready yet
	
	#$html .= "<a href=\"javascript:void window.open('http://127.0.0.1/joomla/index2.php?option=com_estateagent&amp;act=object&amp;task=showEO&id=$obj', 'win2', 'status=no,toolbar=no,scrollbars=yes,titlebar=no,menubar=no,resizable=yes,width=640,height=480,directories=no,location=no');\" title=\"Drucken\">";
	#$html .= "<img src=\"http://127.0.0.1/joomla/images/M_images/printButton.png\" alt=\"Drucken\" align=\"middle\" name=\"image\" border=\"0\" /></a>";
	
}

// generates the locationsearch querystring
function createLocationSearchQuery($country,$state,$town,$district){

		$locations = array($country,$state,$town,$district);
		$fields = array("country","state","town","district");
    	$results = array(); // Array for saving location-part of querystring
        
        $x=0;
        foreach($locations as $lc){
        	$check=0;
        	if($lc == "" || $lc == "no"){
        		$x++;
        		continue;
        	}
        	
        	// checks if one of the last locationfield-parts was set
        	for($y=0;$y<$x;$y++){
        		if($x>=1 && (isset($results[$y]) && $results[$y]!="")){
           			$check = 1;           			
           		}
        	}
        	if($check==1) $results[$x] = " AND " . $fields[$x]."='".$lc."' ";
            else $results[$x] = $fields[$x]."='".$lc."' ";            	
            
        	$x++;     
        }
        
        $query = "";
       	foreach($results as $r){
       		if(isset($r) && $r!="") $query .= $r;
       		else continue;
       	}
        return $query;       
               
}

// generates the extendedsearch querystring
function createExtendedSearchQuery($space,$yobuilt,$rooms,$bedrooms,$minrent=0,$maxrent=0,$minprice=0,$maxprice=0,$special){

		$attributes = array($space,$yobuilt,$rooms,$bedrooms,$minrent,$maxrent,$minprice,$maxprice);
		$year = date("Y");
		$results = array(); // saves parts of querystring
        
        $x=0;                        				
	    foreach($attributes as $a){       				
        	$check = "";
        	$results[$x] = "";

        	if($a=="" || $a==0) {
        		$x++;
        		continue;
        	}
                    			
        	// checks if one of the last fields was set
            for($y=0;$y<$x;$y++){
            	if($x >= 1 && $results[$y]!= ""){
            		$check = " AND ";
					break;            		
            	}
            }
            
            if($x==0) {  //Dwelling-space
            	if($a==1) $results[$x] = $check . "space<'51'";
            	elseif($a==2) $results[$x] = $check . "space>'39' AND space<'81'";
            	elseif($a==3) $results[$x] = $check . "space>'69' AND space<'121'";
            	elseif($a==4) $results[$x] = $check . "space>'109' AND space<'161'";
            	elseif($a==5) $results[$x] = $check . "space>'149' AND space<'221'";
           		elseif($a==6) $results[$x] = $check . "space>'199' AND space<'301'";
           		else $results[$x] = $check . "space>='299'";
            }
           	elseif($x==1) { //Year of built                    				
            	if($a==1) $results[$x] = $check . "yobuilt='".$year."'";
            	elseif($a==2) $results[$x] = $check . "yobuilt>'".$year=($year-10)."'";
            	elseif($a==3) $results[$x] = $check . "yobuilt>'".$year=($year-20)."'";
            	elseif($a==4) $results[$x] = $check . "yobuilt>'".$year=($year-40)."'";
            	elseif($a==5) $results[$x] = $check . "yobuilt>'".$year=($year-60)."'";
                elseif($a==6) $results[$x] = $check . "yobuilt>'".$year=($year-80)."'";
                else $results[$x] = $check . "yobuilt<'".$year=($year-80)."'";
            }
            elseif($x==2) { //Number of rooms
            	if($a==1) $results[$x] = $check . "rooms='1'";
            	elseif($a==2) $results[$x] = $check . "rooms>'1'";
            	elseif($a==3) $results[$x] = $check . "rooms>'2'";
            	elseif($a==4) $results[$x] = $check . "rooms>'3'";
            	elseif($a==5) $results[$x] = $check . "rooms>'4'";
            	elseif($a==6) $results[$x] = $check . "rooms>'5'";
            	elseif($a==7) $results[$x] = $check . "rooms>'6'";
            	else $results[$x] = $check . "rooms>'7'";
            }
			elseif($x==3) { //Number of bedrooms
            	if($a==1) $results[$x] = $check . "bedrooms='1'";
            	elseif($a==2) $results[$x] = $check . "bedrooms>'1'";
            	elseif($a==3) $results[$x] = $check . "bedrooms>'2'";
            	elseif($a==4) $results[$x] = $check . "bedrooms>'3'";
            	elseif($a==5) $results[$x] = $check . "bedrooms>'4'";
            	elseif($a==6) $results[$x] = $check . "bedrooms>'5'";
            	elseif($a==7) $results[$x] = $check . "bedrooms>'6'";
            	else $results[$x] = $check . "bedrooms>'7'";
            }
            elseif($x==4) { // Minimal Rent
            	$results[$x] = $check . "rent >= '".$a."' ";
            }
            elseif($x==5) { // Maximal Rent
            	$results[$x] = $check . "rent <= '".$a."' ";
            }
			elseif($x==6) { // Minimal Price
            	$results[$x] = $check . "price >='".$a."' ";
            }
            elseif($x==7) { // Maximal Price
            	$results[$x] = $check . "price <= '".$a."' ";
            }                        
            $x++;
       	}
		
		$query = "";
		// generate attributes part of querystring
       	foreach($results as $r){
       		if($r==0 || $r=="") $query .= $r;
			else $query .= " AND " . $r;
       	}
		
		// add extended attributes, if checked
		if($special){
			$x=0; $y = count($special);
			foreach($special as $s){
				if($x==0 && $query=="") $query .= "$s='1'";
				else $query .= " AND $s='1'";
				$x++;		
			}       
		}
		
		return $query;
}

// loads the locations for generatng the location selectfields for the searchform 
function getMap($todate){
	global $database;
			
	$query = "SELECT country, state, town, district"
			. " FROM #__estateagent"
			. " WHERE"
			. " verified=1"
			. " AND publish=1";
    $database->setQuery($query);
    $result = $database->loadObjectList();
	#echo $database->getErrorMsg();	
	
	return $result;
}


// ************** MAP24 functions ***********************

function map24CntSelectList(){	
	global $mosConfig_absolute_path;
	
	require($mosConfig_absolute_path."/components/com_estateagent/includes/map24.inc.php");
					
	$o = array();
	while(list($key,$val) = each($map24_countries)) { 
		$o[] = mosHTML::makeOption( $key, $val );	
	}
	return $o;		
}

// generates HTML selectlist for configuring the default map24 user language	
function map24LgSelectList(){ 
	global $mosConfig_absolute_path;
	
	require($mosConfig_absolute_path."/components/com_estateagent/includes/map24.inc.php");
			
	$l = array();
	$l[] = mosHTML::makeOption( "UDEF", _UDEF );
	while(list($key,$val) = each($map24_languages)) { 
		$l[] = mosHTML::makeOption( $key, $val );	
	}
	return $l;		
}

// generates a MAP24 - link for showing on the objects site at the frontend 	
function checkMAP24Sup($lid,$type,$address,$pcode,$town,$country,$logo,$name,$dlg,$dinfo,$dimg ){
	global $mosConfig_absolute_path;
	
	$result = "";

	require($mosConfig_absolute_path."/components/com_estateagent/includes/map24.inc.php");

	// check if user language is supported by map24...	
	$lang = "en";
	if($dlg == "UDEF" && isset($_SERVER['HTTP_ACCEPT_LANGUAGE']) ){
		$lang = substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2);
	}
	elseif($dlg != "UDEF"){
		$lang = $dlg;
	}
		
	// check if theres a map24-server, which supports the users language
	$server = "link2.map24.com";
	while(list($key,$val) = each($map24_servers)) { 
		if($lang == $key){
			$server = $val;
			break;
		}
	}
	
	// check, if the objects country is supported by map24	
	while(list($key,$val) = each($map24_countries)) { 
		if($country == $key){	
			$result  = "<!-- Code generated by Map24.codegenerator and MisterEstate 1.0 --><a href='http://" . $server
						. "?lid=".$lid."&maptype=".$type."&width0=1500&street0=".$address."&zip0=".$pcode."&city0=".$town."&country0="
						. $country."&logo_url0=".$logo."&name0=".$name."&description0=".$dinfo."&lang0=".$lang
						. "' target='_blank'><img src=\"".$dimg."\" border=0 title=\"powered by Map24.com\" /></a><!-- // Map24 -->";
			break;
		}
	}
	return $result;	
}

?>