<?php

/* ************************************************************************************
MisterEstate - a Joomla Component

File:			details.php (Extended Template)
Copyright: 		2004 - 2007 by Darko Selesi
Homepage: 		http://www.misterestate.com
License: 		MEOpenSource:
				- You are authorized to make necessary modification(s) to this file
				  to fit your purposes.
				- You may NOT redistribute or resale this file
				  without prior written consent from MisterEstate.com.   
************************************************************************** */

class METemplate{
	
	var $current = 'default';
	
	var $css = '';	
	
	var $headlines = 0;
	
	var $path = '';
	
	var $gallerymode = 'slide';
		
	var $pictures = 0;
	
	var $mmfiles = 0;
	
	var $googlemaps = 0;
		
	var $thumbsdirection = 'horzontal';
	
	var $thumbsinline = 1;
		
				
	function getFrontendTemplates(){
		global $mosConfig_absolute_path;
		
		$DS=DIRECTORY_SEPARATOR;
		
		$tpath= $mosConfig_absolute_path.$DS.'components'.$DS.'com_estateagent'.$DS.'gui'.$DS."templates";
		
		$templates=array();
		$templateDirs = mosReadDirectory($tpath);
		foreach($templateDirs as $t){
			if(is_dir($tpath.$DS.$t)){
				if(file_exists($tpath.$DS.$t.$DS."details.php") )
				{
					$templates[]= $t ;
				}				
			}		
		}
		return $templates;	
	}
	
	function setCurrent($tmpl){		
		$this->current = $tmpl;
		$this->setCurrentPath();
		$this->loadConfig();		
	}
				
	function setCurrentPath(){
		global $mosConfig_absolute_path;
	
		$DS=DIRECTORY_SEPARATOR;
		if(!is_dir($mosConfig_absolute_path .$DS.'components'.$DS.'com_estateagent'.$DS.'gui'.$DS."templates".$DS.$this->current))
			$this->path = false;	
		else{
			$this->path = $mosConfig_absolute_path.$DS.'components'.$DS.'com_estateagent'.$DS.'gui'.$DS."templates".$DS.$this->current.$DS;
		}
	}
	
	function getCurrent(){
		return $this->current;
	}
	
	function getCurrentPath(){
		
		return $this->path;
		
	}
	
	function loadConfig(){
		
		include($this->path."config.php");
		
		$this->css = $config['css'];
		$this->headlines = $config['headlines'];
		$this->googlemaps = $config['googlemaps'];
		$this->thumbsdirection = $config['thumbsdirection'];
		$this->thumbsinline = $config['thumbsinline'];
		
	}
	
	function initGallery($type){
		
		$this->gallerymode = $type;
		
		if($this->gallerymode == 'lightbox') $this->initLightbox();
		if($this->gallerymode == 'thickbox') $this->initThickbox();
	
	}
		
	function assign($key,$data){
		
		if(trim($data) != "" && trim($data) != "<br>" && trim($data) != "<br />" && trim($data) != "</p>"){
			$this->$key = $data;
		}
		else $this->$key = null;
		
	}
	
	function prepareAttributesHTML($key,$data){
		
		if($this->css=='me') $class = 'class="MEAttributes"';
		
		$this->$key = '';
		$this->$key .= '<table '.$class.' border="0" cellspacing="2" cellpadding="2">';
        if($this->headlines) $this->$key .= '<tr><th '.$class.' colspan="4">'._EA_OBJ_DATA.'</th></tr>';        		
        
        $cols=0;$rows=0;     
        while(list($k,$val) = each($data)) {        	
        	if($val!='' && $val!='0'){
        		if($cols%2==0){
        			$this->$key .= '<tr>';
        		} 
        		$this->$key .= '<td '.$class.' style="width:30%">'.$k.'</td>';
        		$this->$key .= '<td '.$class.' style="width:20%">'.$val.'</td>';
        		$cols++;
        	}
        	$rows++;
        	if(count($data)==$rows && $cols%2!=0){
        		$this->$key .= '<td colspan="2" '.$class.$suffix.' style="width:50%">&nbsp;</td></tr>';
        	}
			if($val!=0 && $val!="" && $val!=0.00 && $cols%2==0) $this->$key .= '</tr>';        			       			        			
        }        				
        
        $this->$key .= '</table>';
               		
	}
	
	function prepareFinancialHTML($key,$data,$sep1,$sep2){
		global $ea_currency;		
		
		if($this->css=='me') $class = 'class="MEFinancial"';
				
		$this->$key = '';
		$this->$key .= '<table '.$class.' width="100%" border="0" cellspacing="2" cellpadding="2">';
		if($this->headlines) $this->$key .= '<tr><th '.$class.' colspan="4">'._EA_OBJ_PRICES.'</th></tr>';				
        
        $cols=0;$rows=0;        	
        while(list($k,$val) = each($data)) {
        	if($val!='' && $val!='0'){
        		if($cols%2==0){
        			$this->$key .= '<tr>';
        		} 
        		$this->$key .= '<td '.$class.' style="width:20%">'.$k.'</td>';
        		$this->$key .= '<td '.$class.' style="width:30%">';
        		if($k != _EA_OBJ_COMMIS) $this->$key .= number_format($val,0,$sep2,$sep1)."&nbsp;".$ea_currency;
        		else $this->$key .= $val;
        		$this->$key .= '</td>';
        		$cols++;
        	}
        	$rows++;
        	if(count($data)==$rows && $cols%2!=0){
        		$this->$key .= '<td colspan="2" '.$class.' style="width:50%">&nbsp;</td></tr>';
        	}
			if($val!=0 && $val!="" && $val!=0.00 && $cols%2==0) $this->$key .= '</tr>';        			       			        			
        }
        
        $this->$key .= '</table>';
              		
	}
	
	function prepareLocationHTML($key,$data,$fulllocation) {
		
		if($this->css=='me') $class = 'class="MELocation"';
		
		$this->$key = '';		
		$this->$key .= '<table '.$class.' width="100%" border="0" cellspacing="2" cellpadding="2">';
		if($this->headlines) $this->$key .= '<tr><th '.$class.'>'._EA_OBJ_ADDRESS.'</th></tr>';
		
		if($fulllocation && $data->street != "")
        	$this->$key .= '<tr><td '.$class.'>'.$data->street." ".$data->streetnr.'</td></tr>';
        $this->$key .= '<tr><td '.$class.'>'.$data->pcode.' '.$data->town.'</td></tr>';
        $this->$key .= '<tr><td '.$class.'>'.$data->district.'</td></tr>';
        if($data->state!="")
        	$this->$key .= '<tr><td '.$class.'>'.$data->state.'</td></tr>';
        $this->$key .= '<tr><td '.$class.'>'.$data->country.'</td></tr>';
        $this->$key .= '</table>';
				
	}
	
	function prepareContactHTML($key,$data){
		
		if($this->css=='me') $class = 'class="MEContact"';
		
		$this->$key = '';
		$this->$key .= '<table '.$class.' width="100%" border="0" cellspacing="2" cellpadding="2">';
		if($this->headlines) $this->$key .= '<tr><th '.$class.'>'._EA_CTF_CONTACTADRESS.'</th></tr>';
		
		$this->$key .= '<tr><td '.$class.'>';		
		if($data->name !="") 		$this->$key .= $data->name . "<br />";
		if($data->postcode != "") 	$this->$key .= $data->postcode . " ";
		if($data->address != "") 	$this->$key .= $data->address . "<br />";
		if($data->suburb != "") 	$this->$key .= $data->suburb . "<br />";
		if($data->country != "") 	$this->$key .= $data->country . "<br /><br />";
		if($data->telephone != "") 	$this->$key .= _CONTACT_HEADER_PHONE . ": " . $data->telephone . "<br />";
		if($data->fax != "") 		$this->$key .= _CONTACT_HEADER_FAX . ": " . $data->fax . "<br />";
		if($data->email_to != "") 	$this->$key .= mosHTML::emailCloaking( $data->email_to ) . "<br /><br />";
		$this->$key .= '</td></tr></table>';
				
	}	
	
	function prepareGalleryHTML($key,$pictures,$files,$params){
		global $mosConfig_live_site;
		
		if($this->css=='me') $class = 'class="MEGallery"';		
				
		$this->$key .= '<table '.$class.' border="0" cellspacing="0" cellpadding="0">';
		$this->$key .= '<tr><td '.$class.'>';
		
		$x=0;				
		foreach($pictures as $pic){	    				
	   		   		
	   		$image = $mosConfig_live_site.$params['picpath'].$pic->fname.$pic->type;
	   		$thumb = $mosConfig_live_site.$params['picpath']."t".$pic->fname.$pic->type;
	   			
	   		if($this->gallerymode=='lightbox'){	   			   		
	   			$this->$key .= '<a '.$class.' href="'.$image.'" rel="lightbox[object]">';								
				$this->$key .= '<img src="'.$thumb.'" title="'.$pic->title.'" hspace="1px" vspace="1px" border="0" width="'.$params['tbwidth'].'px" onMouseOver="return overlib(\''.$pic->description.'\', CAPTION, \''.$pic->title.'\', BELOW, RIGHT);" onMouseOut="return nd();">';
				$this->$key .= '</a>';
	   		}
	   		
	   		if($this->gallerymode=='thickbox'){
	   			$this->$key .= '<a class="thickbox" href="'.$image.'" rel="gallery" title="'.htmlentities($pic->title).'" name="'.htmlentities($pic->description).'" >';
				$this->$key	.= '<img src="'.$thumb.'" title="'.$pic->title.'" hspace="1px" vspace="1px" border="0" width="'.$params['tbwidth'].'px" onMouseOver="return overlib(\''.$pic->description.'\', CAPTION, \''.$pic->title.'\', BELOW, RIGHT);" onMouseOut="return nd();" />';
				$this->$key .= '</a>';
			}
	   			   		
	   		if($this->thumbsdirection=='vertical') $this->$key .= '<br />';
       		$x++;
       		if($this->thumbsdirection=='horizontal' && $x%$this->thumbsinline == 0) $this->$key .= '<br />';
       		
       		
       	}
	   	$this->pictures = $x;
	   	
	   	if($this->gallerymode=='thickbox') {
								
			$media = array('mov','pdf','msdoc','ooffice');$x=0;
			foreach($media as $type){
				foreach($files[$type] as $f){						
					$f->ftype = strtolower(substr($f->type,-3));						
					$file = sefRelToAbs($mosConfig_live_site.$f->path.$f->fname.$f->type)."?KeepThis=true&TB_iframe=true&height=400&width=600";
					$symbol = sefRelToAbs($mosConfig_live_site."/components/com_estateagent/gui/".$f->ftype.".png");
					$this->$key .= '<a class="thickbox" href="'.$file.'"  title="'.htmlentities($f->title).'" name="'.htmlentities($f->description).'" >';
					$this->$key	.= '<img src="'.$symbol.'" title="'.$f->title.'" hspace="1px" vspace="1px" border="0" />';
					$this->$key .= '</a>';
					if($this->thumbsdirection=='vertical') $this->$key .= '<br />';
					if($this->thumbsdirection=='horzontal' && $x%$this->thumbsinline == 0) $this->$key .= '<br />';
       				$x++;
				}
			}
			$this->mmfiles = $x;
		}
			   	
	   	$this->$key .= '</td></tr></table>';
	   	
	}
		
	function initLightbox(){
		global $mosConfig_live_site;
		
		// load gallery scripts -> "lightbox"
    	echo '<script type="text/javascript" src="'.$mosConfig_live_site.'/components/com_estateagent/includes/gallery/lightbox/js/prototype.js"></script>';
		echo '<script type="text/javascript" src="'.$mosConfig_live_site.'/components/com_estateagent/includes/gallery/lightbox/js/scriptaculous.js?load=effects"></script>';
		echo '<script type="text/javascript" src="'.$mosConfig_live_site.'/components/com_estateagent/includes/gallery/lightbox/js/lightbox.js"></script>';
    	echo '<link rel="stylesheet" href="'.$mosConfig_live_site.'/components/com_estateagent/includes/gallery/lightbox/css/lightbox.css" type="text/css" media="screen" />';
    					
	}
	
	function initThickbox() {
		global $mainframe,$mosConfig_absolute_path,$mosConfig_live_site; 
		
		// load gallery scripts -> "thickbox"		
		$tpath = $mosConfig_live_site."/components/com_estateagent/includes/gallery/thickbox/";
		$mainframe->addCustomHeadTag("<link rel=\"stylesheet\" href=\"".$tpath."thickbox.css\" type=\"text/css\" media=\"screen\" />\n");
			
		require($mosConfig_absolute_path."/components/com_estateagent/includes/gallery/thickbox/browser.php");
		$browser = new browser;
		if ( $browser->Name == 'Firefox' ||($browser->Name == 'msie'&& $browser->Version >= 7)  )
		{ 
			echo '<style type="text/css">';
			echo '<!--
					a.thickbox, a.thickbox:visited, a.thickbox:active 
					{
						text-align:center;
						margin:1px;
					}
					
					a.thickbox img, a.thickbox img:visited, a.thickbox img:active 
					{
						border:1px solid #FFF;
					}
			
					a.thickbox:hover img 
					{
						border:1px solid #3E5BEA;
					}
					-->
					</style>';
		}
			
		echo '<script type="text/javascript">';
		echo '	var LOADINGPATH= "'.$tpath.'"';
		echo '</script>';
		echo '<script type="text/javascript" src="'.$tpath.'jquery.js"></script>';
		echo '<script type="text/javascript" src="'.$tpath.'thickbox.js"></script>';				
				
	}
		
	function load(){
		global $mosConfig_live_site;
		
		if($this->css=='me'){
			echo '<link rel="stylesheet" href="'.$mosConfig_live_site.'/components/com_estateagent/gui/templates/'.$this->current.'/template_css.css" type="text/css" media="screen" />';
		}		
		
		include($this->path."details.php");
	}
		
}
?>