<?php
/**
* @version $Id: rss.php 5070 2006-09-15 16:24:06Z friesengeist $
* @package Joomla
* @subpackage Syndicate
* @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*
* modified to fit the needs of MisterEstate 
* by Darko Selesi
* 27.03.2007
* 
*/

// ensure this file is being included by a parent file
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

global $database, $mainframe, $my, $Itemid, $mosConfig_cachepath, $mosConfig_absolute_path, $mosConfig_live_site;
global $mosConfig_sitename;
	  	
  	
  	$info = null;
    $rss  = null;
	$showFeed = true;
	
	$nullDate = $database->getNullDate();
	// pull id of syndication component
	$query = "SELECT a.id"
	. "\n FROM #__components AS a"
	. "\n WHERE ( a.admin_menu_link = 'option=com_syndicate' OR a.admin_menu_link = 'option=com_syndicate&hidemainmenu=1' )"
	. "\n AND a.option = 'com_syndicate'";
	$database->setQuery( $query );
	$id = $database->loadResult();
 
	// load syndication parameters
	$component = new mosComponent( $database );
	$component->load( (int)$id );
	$params = new mosParameters( $component->params );
 
	// test if security check is enbled
	$check = $params->def( 'check', 1 );
	if($check) {
		// test if rssfeed module is published
	    // if not disable access
	    $query = "SELECT m.id"
	    . "\n FROM #__modules AS m"
	    . "\n WHERE m.module = 'mod_rssfeed'"
	    . "\n AND m.published = 1";
	    $database->setQuery( $query );
	    $check = $database->loadResultArray();
	    if(empty($check)) {
	    	mosNotAuth();
	        return;        
        }            
	}
    
	$now     = _CURRENT_SERVER_TIME;
	$iso     = split( '=', _ISO );
  
	// parameter intilization
	$info[ 'date' ]             = date( 'r' );
	$info[ 'year' ]             = date( 'Y' );
	$info[ 'encoding' ]         = $iso[1];
	$info[ 'link' ]             = htmlspecialchars( $mosConfig_live_site );
	$info[ 'cache' ]            = $params->def( 'cache', 1 );
	$info[ 'cache_time' ]       = $params->def( 'cache_time', 3600 );
	$info[ 'count' ]            = $params->def( 'count', 5 );
	$info[ 'orderby' ]          = $params->def( 'orderby', '' );
	$info[ 'title' ]            = $params->def( 'title', 'MisterEstate.com powered site' );
	$info[ 'description' ]      = $params->def( 'description', 'MisterEstate site syndication' );
	$info[ 'image_file' ]       = $params->def( 'image_file', 'joomla_rss.png' );
	if ( $info[ 'image_file' ] 	== -1 ) {
		$info[ 'image' ]        = NULL;
	} else{
		$info[ 'image' ]        = $mosConfig_live_site .'/images/M_images/'. $info[ 'image_file' ];
	}
	$info[ 'image_alt' ]        = $params->def( 'image_alt', 'Powered by MisterEstate.com' );
	$info[ 'limit_text' ]      	= $params->def( 'limit_text', 0 );
	$info[ 'text_length' ]      = $params->def( 'text_length', 20 );
	// get feed type from url
	$info[ 'feed' ]            	= strval( mosGetParam( $_GET, 'feed', 'RSS2.0' ) );
	
	// live bookmarks
	$info[ 'live_bookmark' ]    = $params->def( 'live_bookmark', '' );
	$info[ 'bookmark_file' ]    = $params->def( 'bookmark_file', '' );
   
	// set filename for live bookmarks feed
	if ( !$showFeed & $info[ 'live_bookmark' ] ) {
		if ( $info[ 'bookmark_file' ] ) {
		   	// custom bookmark filename
			$filename = $info[ 'bookmark_file' ];
	 	} else {
	 	   	// standard bookmark filename
	       	$filename = $info[ 'live_bookmark' ];
	    }
	} else {
		// set filename for rss feeds
		$info[ 'file' ] = strtolower( str_replace( '.', '', $info[ 'feed' ] ) );
        #$info[ 'file' ] = "RSS20";	   
		// security check to limit arbitrary file creation.
	   	// and to allow disabling/enabling of selected feed types
		
		switch ( $info[ 'file' ] ) {
	    	case 'rss091':            
	        	if ( !$params->get( 'rss091', 1 ) ) {
	            	echo _NOT_AUTH;
	                return;
	            }
	            break;
  	
	        case 'rss10':            
	        	if ( !$params->get( 'rss10', 1 ) ) {
	            	echo _NOT_AUTH;
	                return;
	            }
	            break;
              
	        case 'rss20':            
	        	if ( !$params->get( 'rss20', 1 ) ) {
	            	echo _NOT_AUTH;
	                return;
	            }
	            break;
             
	        case 'atom03':            
	        	if ( !$params->get( 'atom03', 1 ) ) {
	            	echo _NOT_AUTH;
	                return;
	            }
	            break;
	              
	        case 'opml':            
	        	if ( !$params->get( 'opml', 1 ) ) {
	            	echo _NOT_AUTH;
	                return;
	            }
	            break;
              
              
	        default:
	        	echo _NOT_AUTH;
	            return;
	            break;           
		}
	}
	$filename = $info[ 'file' ].'.xml';
	      
	// security check to stop server path disclosure
	if ( strstr( $filename, '/' ) ) { 
		echo _NOT_AUTH;
	    return;
	}
		
	$info[ 'file' ] = $mosConfig_cachepath .'/'. $filename;
  	#$info[ 'file' ] = $mosConfig_absolute_path .'/cache/'. $filename;
	// load feed creator class
	$rss     = new UniversalFeedCreator();
	// load image creator class
	$image     = new FeedImage();
  
	// loads cache file
	if ( $showFeed && $info[ 'cache' ] ) {
		$rss->useCached( $info[ 'feed' ], $info[ 'file' ], $info[ 'cache_time' ] );
	}
  
	$rss->title             = $info[ 'title' ];
	$rss->description       = $info[ 'description' ];
	$rss->link              = $info[ 'link' ];
	$rss->syndicationURL    = $info[ 'link' ];
	$rss->cssStyleSheet     = NULL;
	$rss->encoding          = $info[ 'encoding' ];
  
	if ( $info[ 'image' ] ) {
		$image->url         = $info[ 'image' ];
	    $image->link        = $info[ 'link' ];
	    $image->title       = $info[ 'image_alt' ];
	    $image->description = $info[ 'description' ];
	    // loads image info into rss array
	    $rss->image         = $image;
	}
  	  
	$query = "SELECT id, title, description AS text, UNIX_TIMESTAMP( created ) AS created_ts"
				. " FROM jos_estateagent"
				. " WHERE ("
				. " ((publish_up = '0000-00-00' AND publish_up = '2007-03-30')"
				. " AND publish_down = '$today') OR ((publish_up = '0000-00-00' AND publish_up = '$today')"
				. " AND (publish_down = '0000-00-00' OR publish_down = '$today')) OR (publish_up = '0000-00-00' AND publish_down = '0000-00-00'))"
				. " AND verified =1 AND publish =1 ORDER BY created ASC LIMIT 0 , 30";        
	$database->setQuery($query);
    $rows = $database->loadObjectList();
	if(count($rows)>0){  
		foreach ( $rows as $row ) {
			// title for particular item
		    $item_title = htmlspecialchars( $row->title );
		    $item_title = html_entity_decode( $item_title );
  	
  		    // url link to article
		    // & used instead of &amp; as this is converted by feed creator
		    $item_link = 'index.php?option=com_estateagent&act=object&task=showEO&id='.$row->id;
		    $item_link = sefRelToAbs( $item_link );
  
		    // removes all formating from the intro text for the description text
		    $item_description = $row->text;
		    $item_description = mosHTML::cleanText( $item_description );
		    $item_description = html_entity_decode( $item_description );
		    if ( $info[ 'limit_text' ] ) {
		    	if ( $info[ 'text_length' ] ) {
		        	// limits description text to x words
		            $item_description_array = split( ' ', $item_description );
		            $count = count( $item_description_array );
	    	        if ( $count > $info[ 'text_length' ] ) {
	    	        	$item_description = '';
	    	            for ( $a = 0; $a < $info[ 'text_length' ]; $a++ ) {
	    	            	$item_description .= $item_description_array[$a]. ' ';
	    	            }
	    	            $item_description = trim( $item_description );
	    	            $item_description .= '...';
	    	        }
	    	    } else  {
	    	    	// do not include description when text_length = 0
	    	        $item_description = NULL;
	    	    }
	    	}
	  
	    	// load individual item creator class
	    	$item = new FeedItem();
	    	// item info
	    	$item->title        = $item_title;
	    	$item->link         = $item_link;
	    	$item->description  = $item_description;
	    	$item->source       = $info[ 'link' ];
	    	$item->date         = date( 'r', $row->created_ts );
	    	  
	  		// loads item info into rss array
	    	$rss->addItem( $item );
		}
	  
		// save feed file
	
		$rss->saveFeed( $info[ 'feed' ], $info[ 'file' ], $showFeed );
	}
	else{		
		mosRedirect($mosConfig_live_site,"Were sorry, but theres no feed available!");
	}
	
?>