<?php
/* **************************************************************************
EstateAgentSearch - a Mambo/Joomla Mambot

File: 			estate.searchbot.php
Copyright: 		2000 - 2006 by clixworx
Homepage: 		http://www.clixworx.net
Version: 		0.1                        
Created with: 	Eclipse 3.1 (http://www.eclipse.org)
License: 		GNU/GPL http://www.gnu.org/copyleft/gpl.html
created by:		clixworx.net
kast change:	22.02.2006
*************************************************************************** */
/**
* @version $Id: sections.searchbot.php 1490 2005-12-20 15:53:29Z Jinx $
* @package Joomla
* @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/


// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );
$_MAMBOTS->registerFunction( 'onSearch', 'botSearchEstate' );

/**
* Sections Search method
*
* The sql must return the following fields that are used in a common display
* routine: href, title, section, created, text, browsernav
* @param string Target search string
* @param string mathcing option, exact|any|all
* @param string ordering option, newest|oldest|popular|alpha|category
*/
function botSearchEstate( $text, $phrase='', $ordering='' ) {
	global $database, $my;

	// load mambot params info
	$query = "SELECT id"
	. "\n FROM #__mambots"
	. "\n WHERE element = 'estate.searchbot'"
	. "\n AND folder = 'search'"
	;
	$database->setQuery( $query );
	$id 	= $database->loadResult();
	$mambot = new mosMambot( $database );
	$mambot->load( $id );
	$botParams = new mosParameters( $mambot->params );
	
	$limit = $botParams->def( 'search_limit', 50 );
	
	 $text = trim( $text );
	if ($text == '') {
		return array();
	}

	switch ( $ordering ) {
		case 'alpha':
			$order = 'title ASC';
			break;
			
		case 'category':
		case 'popular':
		case 'newest':
		case 'oldest':
		default:
			$order = 'title DESC';
	}
	
	$today =  mosCurrentDate( $format="%Y-%m-%d" );

	$query = "SELECT a.title AS title,"
	. "\n a.description AS text,"
	. "\n a.created AS created,"
	. "\n '2' AS browsernav,"
	. "\n a.id AS secid,"
	. "\n c.name AS CatName"
	. "\n FROM #__estateagent AS a,"
	. "\n #__estateagent_categories AS c"
	. "\n WHERE ( a.title LIKE '%".htmlentities($text)."%'"
	. "\n OR a.description LIKE '%".htmlentities($text)."%'"
	. "\n OR a.location LIKE '%".htmlentities($text)."%'"
	. "\n OR a.condition LIKE '%".htmlentities($text)."%'"
	. "\n OR a.other LIKE '%".htmlentities($text)."%'"
	. "\n OR a.street LIKE '%".htmlentities($text)."%'"
	. "\n OR a.town LIKE '%".htmlentities($text)."%')"
	. "\n AND ((a.publish_up <= '$today' AND a.publish_down > '$today')"
	. "\n OR (a.publish_up <= '$today' AND a.publish_down = '0000-00-00'))"
	. "\n AND c.id = a.cat"
	. "\n GROUP BY a.id"
	. "\n ORDER BY $order"
	;

	$database->setQuery( $query, 0, $limit );
	$rows = $database->loadObjectList();

	$count = count( $rows );
	for ( $i = 0; $i < $count; $i++ ) {
			$rows[$i]->href 	= 'index.php?option=com_estateagent&act=object&task=showEO&id='. $rows[$i]->secid;
			$rows[$i]->section 	= "Immobilien/".$rows[$i]->CatName;
	}
	
	return $rows;
}
?>